/*
 *  Copyright (C) 1999, 2000  Heikki Tauriainen <Heikki.Tauriainen@hut.fi>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MacroDefs_h_
#define _MacroDefs_h_

#ifdef HAVE_SGI_STL
#define ALLOC(typename) malloc_alloc
#else
#define ALLOC(typename) allocator<typename>
#endif  /* HAVE_SGI_STL */

#ifdef HAVE_RAND48
#define SRAND(seed) srand48(seed)
#define LRAND(min, max) (min + static_cast<long int>        \
                                 (drand48() * (max - min)))
#define DRAND drand48()
#else
#define SRAND(seed) srand(seed)
#define LRAND(min, max) (min + static_cast<long int>                  \
                                 (static_cast<double>(rand())         \
		                  / static_cast<double>(RAND_MAX + 1) \
                                      * (max - min)))
#define DRAND (static_cast<double>(rand()) / static_cast<double>(RAND_MAX + 1))
#endif  /* HAVE_RAND48 */

#endif  /* _MacroDefs_h_ */
