/*
 *  Copyright (C) 1999, 2000  Heikki Tauriainen <Heikki.Tauriainen@hut.fi>
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

%{
#include <string>
%}

%%

[ \t\n]                    { 
                             /* Skip whitespace. */
                           }
"/*"([^\*]*(\*[^/])?)*"*/" { 
                             /* Skip comments. */
                           }

never                      { 
                             return NEVER;
                           }

if                         {
                             return IF;
                           }

fi                         {
                             return FI;
                           }

goto                       {
                             return GOTO;
                           }

skip                       {
                             return SKIP;
                           }

"::"                       {
                             return DOUBLE_COLON;
                           }

":"                        {
                             return COLON;
                           }

";"                        {
                             return SEMICOLON;
                           }

"{"                        {
                             return LBRACE;
                           }

"}"                        {
                             return RBRACE;
                           }

"("                        {
                             return LPAREN;
                           }

")"                        {
                             return RPAREN;
                           }

"->"                       {
                             return RIGHT_ARROW;
                           }

"p"[0-9]+                  {
                             yylval.pf = new string(yytext);
                             return PROPOSITION;
                           }

"1"|true                   {
                             yylval.pf = new string;
                             *yylval.pf +=
			       FormulaString::FormulaString::LTL_TRUE;
                             return TRUE;
			   }

"0"|false                  {
                             yylval.pf = new string;
			     *yylval.pf +=
			       FormulaString::FormulaString::LTL_FALSE;
                             return FALSE;
                           }

"||"                       {
                             return OR;
                           }

"&&"                       {
                             return AND;
                           }

"!"                        {
                             return NOT;
                           }

[A-Za-z_][A-Za-z0-9_]*     {
                             yylval.str = new string(yytext);
                             return LABEL;
                           }


%%
